#include "StdAfx.h"
#include <vector>
#include "Graph.h"
#include <math.h>
using namespace std;
#define DNORM(rd,id)				sqrt(rd*rd+id*id)


CGraph::CGraph(void)
{
	writecount=0;
	gamenlength=0;
	igdata=NULL;
	qgdata=NULL;
	pOldBmp=NULL;
	FallCounter=0;
	coloroffset=0;

}

CGraph::~CGraph(void)
{
	if(igdata!=NULL){
		delete igdata;
	}
	if(qgdata!=NULL){
		delete qgdata;
	}
	if(pOldBmp!=NULL){
		//cb̃rbg}bv߂
		memDC.SelectObject(pOldBmp);
		//rbg}bv폜
		memBmp.DeleteObject();
		//cb폜
		memDC.DeleteDC();	
	}

}
void CGraph::SetGamen(CRect g)
{
	gamen=g;
}
void CGraph::ResizeMemDC(CPaintDC &pDDC,CRect g)
{

	gamen=g;

	if(pOldBmp!=NULL){
		//cb̃rbg}bv߂
		memDC.SelectObject(pOldBmp);
		//rbg}bv폜
		memBmp.DeleteObject();
		//cb폜
		memDC.DeleteDC();	
	}

	memDC.CreateCompatibleDC(&pDDC);

	//cb̎̂ƂȂrbg}bv쐬
	memBmp.CreateCompatibleBitmap(&pDDC,gamen.Width(),gamen.Height()*2);

	//cbɃrbg}bvI
	pOldBmp=memDC.SelectObject(&memBmp);

}

CRect CGraph::GetGamen()
{
	return gamen;
}

void CGraph::SetLength(int len)
{
	int	i;
	gamenlength=len;
	if(igdata!=NULL){
		delete igdata;
	}
	if(qgdata!=NULL){
		delete qgdata;
	}

	igdata=new double[len];
	qgdata=new double[len];	
	writecount=0;
	for(i=0;i<len;i++){
		igdata[i]=0.0;
		qgdata[i]=0.0;
	}
}
void CGraph::SetData(double ida[],double qda[],int n)
{
	int	i;
	for(i=0;i<n;i++){
		igdata[writecount]=ida[i];
		qgdata[writecount]=qda[i];
		writecount=(writecount+1)%gamenlength;
	}
}
void CGraph::SetColorOffset(int col)
{
	coloroffset=col;
}


//...................................................................................................
void CGraph::DrawFFT(CPaintDC &dc,int point,double samplerate,int startpos,int endpos,int mousepos,double maxlevel)
{
	int	i,j,writec,len;
	CPen pen,backpen,memoripen,mousepen,*oldpen;
	CString	ss;
	CPoint	p0,p1,org;
	CRect	backrect;
	CBrush	backbrush(RGB(10,10,10));
	CBrush	rmarkbrush(RGB(222,222,222));

	double	*rdata;
	double	*idata;
	double	*qdata;
	double	*wdata;
	double	*iqtemp;
	double	xbai;
	int		peakpos[10];
	double	df;


	rdata=new double[point];
	idata=new double[point];
	qdata=new double[point];
	wdata=new double[point];
	iqtemp=new double[point];
	

	//-------------------------- FFT
	CreateWindowFunction(wdata,point);
	writec=(writecount+1)%gamenlength;
	for(i=0;i<point;i++){
		idata[i]=igdata[writec]*wdata[i];
		qdata[i]=qgdata[writec]*wdata[i];
		writec=(writec+1)%gamenlength;
	}
	fft(point,2.0*3.1415/(double)point,idata,qdata);
	j=point/2;
	for(i=0;i<point;i++){
		iqtemp[j--]=log10(idata[i]*idata[i]+qdata[i]*qdata[i])*10.0;
		j=j<0?point-1:j;
	}
	for(i=0;i<point;i++){
		rdata[i]=iqtemp[i];
	}
	CalcPeak(rdata,point,peakpos);
	//
	for(i=0;i<point;i++){
		rdata[i]=rdata[i]/maxlevel*(double)gamen.Height();
	}

	//-----------------------------------
	CDC	memDC;
	CBitmap BM;
	CFont	font,*oldfont;

	BM.CreateCompatibleBitmap(&dc,gamen.Width(),gamen.Height());
	memDC.CreateCompatibleDC(&dc);
	memDC.SelectObject(BM);

	backrect=gamen;
	backrect.OffsetRect(-gamen.left,-gamen.top);
	memDC.FillRect(backrect,&backbrush);
	memoripen.CreatePen(PS_SOLID, 1, RGB(100,100,100));
	oldpen=memDC.SelectObject(&memoripen);

	memDC.MoveTo(0,gamen.Height()-1);
	memDC.LineTo(gamen.Width(),gamen.Height()-1);

	oldfont=memDC.SelectObject(&font);
	memDC.SetBkColor(RGB(0,0,0));
	memDC.SetTextColor(RGB(200,200,200));


	double st,ed;
	st=startpos*(samplerate/(double)point)-samplerate/2.0;
	ed=endpos*(samplerate/(double)point)-samplerate/2.0;

	p0.x=0;
	p0.y=0;
	p1.x=0;
	p1.y=gamen.Width();
	for(i=-200;i<200;i+=10){
		if(((double)i>=st) && ((double)i<=ed)){
			p0.x=(int)((double)gamen.Width()*((double)i-st)/(ed-st));
			p1.x=p0.x;
			memDC.MoveTo(p0);
			memDC.LineTo(p1);
			ss.Format("%dk",i);
			memDC.TextOutA(p0.x,gamen.Height()-20,ss);
		}
	}

	pen.CreatePen(PS_SOLID, 1, RGB(255,255,255));
	memDC.SelectObject(&pen);

	org.x=0;
	org.y=gamen.Height();
	p0=org;
	len=endpos-startpos;
	xbai=gamen.Width()/(double)(len);
	for(i=0;i<len;i++){
		p1.x=org.x+(int)((double)i*xbai);
		p1.y=org.y-(int)(rdata[i+startpos]);
		memDC.MoveTo(p0);
		memDC.LineTo(p1);
		p0=p1;
	}
	df=samplerate/(double)point;
	for(j=0;j<3;j++){
		if(peakpos[j]==-1){
			break;
		}
		ss.Format("%d:%+10.5fkHz",j,((double)peakpos[j]*df)-(samplerate/2.0));
		memDC.TextOutA(20,j*18,ss);
		if((peakpos[j]>=startpos)&&(peakpos[j]<=endpos)){
			p1.x=org.x+(int)((double)(peakpos[j]-startpos)*xbai);
			p1.y=org.y-(int)(rdata[peakpos[j]]);
			memDC.FrameRect(CRect(p1.x-5,p1.y-5,p1.x+5,p1.y+5),&rmarkbrush);
			ss.Format("%d",j);
			memDC.TextOutA(p1.x,p1.y-22,ss);
		}
	}

	mousepen.CreatePen(PS_SOLID, 1, RGB(255,255,255));
	memDC.SelectObject(&mousepen);
	memDC.MoveTo(mousepos,0);
	memDC.LineTo(mousepos,gamen.Height());


	dc.BitBlt(gamen.left,gamen.top,gamen.Width(),gamen.Height(),&memDC,0,0,SRCCOPY);

	memDC.SelectObject(oldfont);
	memDC.SelectObject(oldpen);

	delete	rdata;
	delete	idata;
	delete	qdata;
	delete	wdata;
	delete	iqtemp;
	

}

void CGraph::DrawFFTFall(CPaintDC &dc,int point,int startpos,int endpos)
{
	int	i,j,len;
	CPoint	sp,ep;
	CPen*	oldpen,cpen;
	double xbai;
	COLORREF	cl;
	int	writec;

	double	*rdata;
	double	*idata;
	double	*qdata;
	double	*wdata;
	double	*iqtemp;

	if(pOldBmp==NULL){
		return;
	}

	rdata=new double[point];
	idata=new double[point];
	qdata=new double[point];
	wdata=new double[point];
	iqtemp=new double[point];
	

	//----------- FFT -----------------------
	CreateWindowFunction(wdata,point);
	writec=(writecount+1)%gamenlength;
	for(i=0;i<point;i++){
		idata[i]=igdata[writec]*wdata[i];
		qdata[i]=qgdata[writec]*wdata[i];
		writec=(writec+1)%gamenlength;
	}
	fft(point,2.0*3.1415/(double)point,idata,qdata);
	j=point/2;
	for(i=0;i<point;i++){
		iqtemp[j--]=log10(idata[i]*idata[i]+qdata[i]*qdata[i])*10.0;
		j=j<0?point-1:j;
	}
	for(i=0;i<point;i++){
		rdata[i]=iqtemp[i];
	}
	//-----------
	cpen.CreatePen(PS_SOLID,1,RGB(0,0,0));
	oldpen=memDC.SelectObject(&cpen);
	cpen.DeleteObject();

	len=endpos-startpos;
	xbai=gamen.Width()/(double)len;
	for(i=0;i<len;i++){
		sp.x=(int)((double)i*xbai);
		ep.x=(int)((double)(i+1)*xbai);
		sp.y=ep.y=FallCounter; 
		cl=CalcColor((rdata[startpos+i]+coloroffset)/60.0);
		cpen.CreatePen(PS_SOLID,1,cl);
		memDC.SelectObject(cpen);
		memDC.MoveTo(sp);
		memDC.LineTo(ep);
		sp.y=ep.y=gamen.Height()+FallCounter;
		memDC.MoveTo(sp);
		memDC.LineTo(ep);
		cpen.DeleteObject();


	}



	i=(FallCounter-1)>0?(FallCounter-1):gamen.Height();
	dc.BitBlt(gamen.left,gamen.top,gamen.Width(),gamen.Height(),&memDC,0,i,SRCCOPY);
	FallCounter=(FallCounter-1)>0?(FallCounter-1):gamen.Height();

	memDC.SelectObject(oldpen);

	delete	rdata;
	delete	idata;
	delete	qdata;
	delete	wdata;
	delete	iqtemp;
	

}

void CGraph::DrawIQ(CPaintDC &dc,double xbai,double ybai)
{
	int	i,n;
	CPen pen,backpen,*oldpen;
	CString	ss;
	CPoint	p0,p1,org;
	CRect	backrect;
	CBrush	backbrush(RGB(100,100,100));
	n=gamenlength;
	int	x,y;
	int	writec;

	//pcb
	CDC	memDC;
	CBitmap BM;


	BM.CreateCompatibleBitmap(&dc,gamen.Width(),gamen.Height());
	memDC.CreateCompatibleDC(&dc);
	memDC.SelectObject(BM);

	backrect=gamen;
	backrect.OffsetRect(-gamen.left,-gamen.top);
	memDC.FillRect(backrect,&backbrush);
	backpen.CreatePen(PS_SOLID, 1, RGB(200,200,200));
	oldpen=memDC.SelectObject(&backpen);

	p0.x=0;			p0.y=gamen.Height()/2;	p1.x=gamen.Width();			p1.y=gamen.Height()/2;	
	memDC.MoveTo(p0);
	memDC.LineTo(p1);
	p0.x=gamen.Width()/2;	p0.y=0;	p1.x=gamen.Width()/2;			p1.y=gamen.Height();	
	memDC.MoveTo(p0);
	memDC.LineTo(p1);

	org.x=(gamen.Width()/2);
	org.y=(gamen.Height()/2);
	p0=org;
	p1=org;
	p1.y=(LONG)igdata[writecount];
	writec=writecount;

	pen.CreatePen(PS_SOLID, 1, RGB(255,0,0));
	memDC.SelectObject(&pen);

	for(i=0;i<n;i++){
		x=(int)(igdata[writec]*xbai);
		y=-(int)(qgdata[writec]*ybai);

		writec=(writec+1)%gamenlength;
		p1=CPoint(x,y)+org;
		if(i==0){
			p0=p1;
		}
		memDC.Ellipse(p1.x-1,p1.y-1,p1.x+1,p1.y+1);		
//		memDC.MoveTo(p0);
//		memDC.LineTo(p1);
		p0=p1;
	}

	dc.BitBlt(gamen.left,gamen.top,gamen.Width(),gamen.Height(),&memDC,0,0,SRCCOPY);

	memDC.SelectObject(oldpen);


}
void CGraph::CalcPeak(double *data,int n,int *peakpos)
{
	int	i,j,k;
	double	peak[10];

	for(i=0;i<10;i++){
		peak[i]=-10000.0;
		peakpos[i]=-1;
	}

	for(i=1;i<n-1;i++){
		if((data[i] > data[i-1] ) && (data[i] > data[i+1])){
			for(j=0;j<10;j++){
				if(peak[j]<data[i]){
					for(k=10-1;k>j;k--){			//1炷
						peak[k]=peak[k-1];
						peakpos[k]=peakpos[k-1];
					}
					peak[j]=data[i];				//󂢂ꏊɓ
					peakpos[j]=i;
					break;
				}			
			}
		}
	}
}

//level 0.0~1.0   0.0:black, 1.0:red
COLORREF CGraph::CalcColor(double level)
{

	int index;
	int group;

	index=(int)(1280.0 * (level));
	group = index / 256;			//1280
	if(index<0){
		return RGB(0,0,0);
	}

	if(group==0){
		return RGB(0,0,index);	
	}
	else if(group == 1){
		return RGB(0,index%256,255);	
	}
	else if(group == 2){
		return RGB(0,255,255-(index%256));	
	}
	else if(group == 3){
		return RGB(index%256,255,0);	
	}
	else if(group == 4){
		return RGB(255,255-(index%256),0);
	}
//	else if(group == 5){
	else{
		return RGB(255,0,0);	
	}
	return RGB(0,0,0);

}

void CGraph::CreateWindowFunction(double data[],int nn)
{
	int	i;
	double	x;
	for(i=0;i<nn;i++){
		x=(double)i/(double)nn;
//		data[i]=0.5-0.5*cos(2.0*3.14158*x);	//han
//		data[i]=0.42-0.5*cos(2.0*3.14158*x)+
//			0.08*cos(4.0*3.14158*x);	//blackman
		data[i]=0.3635819-0.4891775*cos(2.0*3.14158*x)+
				0.1365995*cos(4.0*3.14158*x) +
				0.0106411*cos(6.0*3.14158*x);	//Blackman]Harris
	}
}


void CGraph::fft(int n, double theta, double ar[], double ai[])
{
    int m, mh, i, j, k, irev;
    double wr, wi, xr, xi;

    /* ---- scrambler ---- */
    i = 0;
    for (j = 1; j < n - 1; j++) {
        for (k = n >> 1; k > (i ^= k); k >>= 1);
        if (j < i) {
            xr = ar[j];
            xi = ai[j];
            ar[j] = ar[i];
            ai[j] = ai[i];
            ar[i] = xr;
            ai[i] = xi;
        }
    }
    for (mh = 1; (m = mh << 1) <= n; mh = m) {
        irev = 0;
        for (i = 0; i < n; i += m) {
            wr = cos(theta * irev);
            wi = sin(theta * irev);
            for (k = n >> 2; k > (irev ^= k); k >>= 1);
            for (j = i; j < mh + i; j++) {
                k = j + mh;
                xr = ar[j] - ar[k];
                xi = ai[j] - ai[k];
                ar[j] += ar[k];
                ai[j] += ai[k];
                ar[k] = wr * xr - wi * xi;
                ai[k] = wr * xi + wi * xr;

            }

        }
    }
}

