#include "StdAfx.h"
#include "Serial.h"
#include <windows.h>
#include <stdio.h>

#pragma warning ( disable : 4996 )


CSerial::CSerial(void)
{
	hcom=NULL;
}

CSerial::~CSerial(void)
{
	if(hcom!=NULL){
		CloseHandle(hcom);
	}

}

void	CSerial::Close(void)
{
	CloseHandle(hcom);
}

bool	CSerial::Open(int co,int baud)
{
	DCB dc;
	char	comname[128];
	sprintf(comname,"\\\\.\\COM%d",co);
	hcom = CreateFile( comname,
                             GENERIC_WRITE | GENERIC_READ,
                              FILE_SHARE_WRITE | FILE_SHARE_READ,
							NULL,
							OPEN_EXISTING,
							0,
                              NULL
                              );

	if(hcom==INVALID_HANDLE_VALUE){
		hcom=NULL;
		return false;
	}
	//
	GetCommState(hcom, &dc);
    
	dc.fOutxCtsFlow = true;
	dc.fRtsControl = RTS_CONTROL_DISABLE;
	dc.BaudRate = baud;
	dc.fBinary = true;
	dc.fParity = false;
	dc.fOutxCtsFlow = false;
	dc.fOutxDsrFlow = false;
	dc.fDtrControl = DTR_CONTROL_DISABLE;
	dc.fDsrSensitivity = false;
	dc.fTXContinueOnXoff = true;
	dc.fOutX = false;
	dc.fInX = false;
	dc.fErrorChar = false;
	dc.fNull = false;
	dc.fRtsControl = false;
	dc.fAbortOnError = false;
	dc.ByteSize = DATABITS_8;
	dc.Parity = NOPARITY;
	dc.StopBits = ONESTOPBIT;


	if (!SetCommState(hcom, &dc)){
		return false;
	}
	return true;
}
DWORD	CSerial::Read(BYTE *data,DWORD n)
{
	OVERLAPPED	ol;
	DWORD dwRet;
	DWORD	m;

	if(hcom==NULL){
		return 0;
	}
	memset(&ol, 0x00, sizeof(OVERLAPPED));
	ol.hEvent = INVALID_HANDLE_VALUE;
	if(INVALID_HANDLE_VALUE == (ol.hEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL))){
		return -1;
	}
	dwRet=ReadFile(hcom,data,n,&m,&ol);

	if (!dwRet) {
		dwRet = ::GetLastError();
		if(dwRet != ERROR_IO_PENDING) {
			return -1;
		}
	}
	return m;
}
DWORD CSerial::Check(void)
{
	COMSTAT cs;
	DWORD err;
	BOOL	f;
	if(hcom==NULL){
		return 0;
	}
	cs.cbInQue=0;
	f=ClearCommError(hcom,&err,&cs);
	if(f==false){
		return 0;
	}
	else{
		return cs.cbInQue;
	}
}

DWORD	CSerial::Write(BYTE *data,DWORD n)
{
	OVERLAPPED	ol;
	DWORD dwRet;
	DWORD	m;

	if(hcom==NULL){
		return 0;
	}

	memset(&ol, 0x00, sizeof(OVERLAPPED));
	ol.hEvent = INVALID_HANDLE_VALUE;
	if(INVALID_HANDLE_VALUE == (ol.hEvent = ::CreateEvent(NULL, FALSE, FALSE, NULL))){
		return -1;
	}
	dwRet=WriteFile(hcom,data,n,&m,&ol);

	if (!dwRet) {
		dwRet = ::GetLastError();
		if(dwRet != ERROR_IO_PENDING) {
			return -1;
		}
	}
	return m;
}
///////////////

